*  Array.prg
*  ਬ ᯮ짮  ࠡ⪨ ᨢ
*  Copyright (c) 1990-1991 Nantucket Corp.   ࠢ ࠭.
*
*    樨: /n/w/a/m
*
/***********
* 䨪 ந  ""  ५ -  1991 .
*     祭 Nantucket Corp.
* ⥫.: (095) 289-43-00, (095) 289-44-77, (095) 289-44-83
* 䠪: (095) 289-34-69
************/

#include "Inkey.ch"


//  ६ ࠭ ⥪饥 祭 ப  ABrowse()
static nRow


/***
*  ABrowse( <aArray>, <nTop>, <nLeft>, <nBottom>, <nRight> ) --> value
*
*  ᬮ 㬥୮ ᨢ  ᯮ짮 TBrowse-ꥪ⮢
*    祭 뤥 .
*
*   : Jake Jacob  Fleming Ho  // ॢ : ᠭ 㡮᪨
*/

FUNCTION ABrowse( aArray, nT, nL, nB, nR )

   LOCAL n, xRet, nOldNRow, nOldCursor  //  ६
   LOCAL o                              // TBrowse-ꥪ
   LOCAL nKey := 0                      // ࠭  


   // ࠭ ⠭    몫祭
   nOldCursor := SetCursor( 0 )

   // ࠭ 祭 ᪮ ६  ᢮  1
   nOldNRow := nRow
   nRow := 1


   // ࠡ⪠ 饭 ࠬ஢
   nT := IF( nT == NIL, 0, nT )
   nL := IF( nL == NIL, 0, nL )
   nB := IF( nB == NIL, MAXROW(), nB )
   nR := IF( nR == NIL, MAXCOL(), nR )


   //  TBrowse-ꥪ
   o := TBrowseNew( nT, nL, nB, nR )

   // "skip"    ப  ( ⠥ ) nRow
   // (. ASkipTest() )
   o:SkipBlock := { |nSkip|                                             ;
                             nSkip := ASkipTest(aArray, nRow, nSkip),   ;
                             nRow += nSkip,                             ;
                             nSkip                                      ;
                  }

   // "go top"   ⠭ nRow  1
   o:GoTopBlock := { || nRow := 1 }

   // "go bottom"   ⠭ nRow =  ᨢ
   o:GoBottomBlock := { || nRow := LEN(aArray) }

   //      TBColumn-ꥪ⮢  TBrowse
   // (. ABrowseBlock() )
   FOR n = 1 TO LEN( aArray[1] )
      o:AddColumn( TBColumnNew("", ABrowseBlock(aArray, n)) )
   NEXT


   //  ࠢ   
   DO WHILE nKey <> K_ESC .AND. nKey <> K_RETURN

      // ⠡
      nKey := 0
      DO WHILE .NOT. o:Stabilize() // ᫨ ꥪ ⠡,  =>.T.
         nKey := INKEY()           // ᫨ 㦭 த,  .F.
         IF nKey <> 0              //    
            EXIT                   // ⠡ 뢠.
         ENDIF
      ENDDO
                                   // ᫨ ⠡  뢠,
      IF nKey == 0                 //   
         nKey := INKEY(0)
      ENDIF

      // 믮 ⢨  蠬
      IF o:Stable

         DO CASE
         CASE ( nKey == K_DOWN )
            o:Down()

         CASE ( nKey == K_UP )
            o:Up()

         CASE ( nKey == K_RIGHT )
            o:Right()

         CASE ( nKey == K_LEFT )
            o:Left()

         CASE ( nKey == K_PGDN )
            o:Right()
            o:Down()

         CASE ( nKey == K_PGUP )
            o:Right()
            o:Up()

         CASE ( nKey == K_HOME )
            o:Left()
            o:Up()

         CASE ( nKey == K_END )
            o:Left()
            o:Down()

         ENDCASE

      ENDIF

   ENDDO


   // ⠭ 頥 祭
   xRet := IF( nKey == K_RETURN, aArray[nRow, o:ColPos], NIL )

   // ⠭  
   SetCursor( nOldCursor )

   // ⠭ ᪮ 樨 ப
   nRow := nOldNRow


   RETURN (xRet)


/***
*  ABrowseBlock( <a>, <x> ) -> bColumnBlock
*  㭪, 뢠  ABrowse().
*
*  頥 set/get   <a>[nRow, <x>]
*
*   १ ࠡ 頥  , ᯮ騩
*   ६ <a>  <x> (। 㭪樨 ࠬ).
*   ᨨ 5.01   ६ 㯭  ᯮ짮
*     ᫥   㭪樨.
*   १  맮 ABrowseBlock() 頥
*   ,   ᢮ 믮 砥 ࠬ <a>  <x>
*   ⮬   ᯮ ⠪  ᪠ ६
*  nRow, 㦠 ABrowse()  "樨"    ᨢ
*   ६ ᬮ.
*/

STATIC FUNCTION ABrowseBlock(a, x)

   RETURN ( {|p| IF(PCOUNT() == 0, a[nRow, x], a[nRow, x] := p)} )


/***
*  ASkipTest( <a>, <nCurrent>, <nSkip> ) -> nSkipsPossible
*  뢠  ABrowse().
*
*  ஢   ᨢ <a>  ⥪騬 ⮬ <nCurrent>
*  ய <nSkip> ।  
*  頥 ⨬ 祭.
*/

STATIC FUNCTION ASkipTest(a, nCurrent, nSkip)

   IF ( nCurrent + nSkip < 1 )
      //  ३  砫...
      RETURN ( -nCurrent + 1 )

   ELSEIF ( nCurrent + nSkip > LEN(a) )
      //  ३  ...
      RETURN ( LEN(a) - nCurrent )

   END

   //  - ⨬
   RETURN (nSkip)




/***
*  ABlock( <cName>, <nSubx> ) -> bABlock
*
*      ⥭/ 祭  ᨢ,
*  㪠뢠    ६  祭 
*
*  砭: cName    ६,   
*  -᫥ (   LOCAL  STATIC-६). ஬ ⮣,
*      ,  㤥 ᯮ짮  .
*
*
*  砭: ABlock()  ᯮ짮   ᨢ,
*  ᯮ ᭮ ࠦ   cName:
*
*   //  ᮧ set/get    a[i]
*	  b := ABlock( "a", i )
*
*   //  ᮧ set/get    a[i][j]
*	  b :=- ABlock( "a[i]", j )
*
*  砭:  㭪 ᯥ稢 ᮢ⨬  ᨥ
*  5.00 Array.prg. . 㭪 ABrowseBlock() ()
*     ⮤ ࠨ    ᨢ
*   ᯮ짮 .
*
*/

FUNCTION ABlock( cName, nSubx )

LOCAL cAXpr

   cAXpr := cName + "[" + LTRIM(STR(nSubx)) + "]"

   RETURN &( "{ |p| IF(PCOUNT()==0, " + cAXpr + "," + cAXpr + ":=p) }" )


/***
*  AMax( <aArray> ) --> nPos
*  頥   ᨢ  ᨬ 祭.
*/

FUNCTION AMax( aArray )

   LOCAL nLen, nPos, expLast, nElement


   DO CASE

   // 訡 㬥
   CASE VALTYPE( aArray ) <> "A"
      RETURN NIL

   //
   CASE EMPTY( aArray )
      RETURN 0

   OTHERWISE
      nLen := LEN( aArray )
      nPos := 1
      expLast := aArray[1]
      FOR nElement := 2 TO nLen
         IF aArray[nElement] > expLast
            nPos := nElement
            expLast := aArray[nElement]
         ENDIF
      NEXT

   ENDCASE

   RETURN nPos


/***
*  AMin( <aArray> ) --> nPos
*  頥   ᨢ   祭.
*/

FUNCTION AMin( aArray )

   LOCAL nLen, nPos, expLast, nElement


   DO CASE

   // 訡 㬥
   CASE VALTYPE( aArray ) <> "A"
      RETURN NIL

   // ⮩ 㬥
   CASE EMPTY( aArray )
      RETURN 0

   OTHERWISE
      nLen := LEN( aArray )
      nPos := 1
      expLast := aArray[1]
      FOR nElement := 2 TO nLen
         IF aArray[nElement] < expLast
            nPos := nElement
            expLast := aArray[nElement]
         ENDIF
      NEXT

   ENDCASE

   RETURN nPos


/***
*  AComp( <aArray>, <bComp>, [<nStart>], [<nStop>] ) --> valueElement
*  ࠢ   ᨢ, ᯮ bComp    nStart
*   nStop (᫨ 㪠. ,  ᨢ)  頥 १.
*   Array.ch ।⠢ ਬ ࠧ 
*/
FUNCTION AComp( aArray, bComp, nStart, nStop )
   LOCAL value := aArray[1]

   AEVAL(                                                               ;
          aArray,                                                       ;
          {|x| value := IF( EVAL(bComp, x, value), x, value )},         ;
          nStart,                                                       ;
          nStop                                                         ;
        )

   RETURN( value )


/***
*  Dimensions( <aArray> ) --> aDims
*  頥 ᨢ ᫮ 祭, 뢠騩 ࠧ୮
*     ᨢ. ।,   ᨢ
*    ࠧ୮ (᫥ ந   ⠬)
*/

FUNCTION Dimensions( aArray )
   LOCAL aDims := {}

   DO WHILE ( VALTYPE(aArray) == "A" )
      AADD( aDims, LEN(aArray) )
      aArray := aArray[1]
   ENDDO

   RETURN (aDims)