/***
*  Odemo2.prg
*   ਠ ᯮ짮 OMENU ⥬
*
*  Copyright (c) 1990 Nantucket Corp.   ࠢ ࠭.
*  Craig Ogg
*
*/
/***********
* 䨪 ந  ""  ५ -  1991 .
*     祭 Nantucket Corp.
* ⥫.: (095) 289-43-00, (095) 289-44-77, (095) 289-44-83
* 䠪: (095) 289-34-69
************/

#include "Omenu.ch"
#include "Inkey.ch"
#include "Memoedit.ch"

/* ।    権  */

// ।  
#define F_GET      10
#define F_MEMO     11
#define F_SAVE     12
#define F_SAVEAS   13
#define F_PRINT    14
#define F_EXIT     15

// ।  権 
#define SA_NORM   131
#define SA_WK1    132
#define SA_DBF    133

#define DB_CLIP   1331
#define DB_III    1332
#define DB_IV     1333

#define E_UNDO       20
#define E_CUT        21
#define E_COPY       22
#define E_PASTE      23
#define E_CLEAR      24

#define S_BELL       30
#define S_WRAP       31
#define S_CONFIRM    32


STATIC hBar, hFileMenu, hEditMenu, hSetMenu, hSaveSubMenu, hdBASESub

FUNCTION Odemo2()
   LOCAL nChoice

   // 㭪樨, 뢠騥,  ᮧ  (. )
   CreateBar()

   CLS
   @ 12, 0 SAY " ⨢樨   <F10>  Alt-<뤥 㪢>..."

   // 砫쭮   ࠢ ਧ. 
   BarActivate( hBar )
   nChoice := BarMenuChoice( hBar )
   DO WHILE nChoice != F_EXIT
      DO CASE
      CASE nChoice == F_GET
          DO GetProc
      CASE nChoice == F_MEMO
          DO MemoProc
      CASE nChoice == F_PRINT
          DummyProc("樨 .")
      CASE nChoice == SA_NORM
          DummyProc("࠭ 䠩.")
      CASE nChoice == SA_WK1
          DummyProc("࠭ 䠩  ଠ Lotus.")
      CASE nChoice == DB_CLIP
          DummyProc("࠭ 䠩  ଠ Clipper.")
      CASE nChoice == DB_III
          DummyProc("࠭ 䠩  ଠ  dBASE III+.")
      CASE nChoice == DB_IV
          DummyProc("࠭ 䠩  ଠ  dBASE IV.")
      OTHERWISE
          BarActivate( hBar )
      ENDCASE
      nChoice := BarMenuChoice( hBar )
   ENDDO

   RETURN NIL


/***
*  CreateBar() --> NIL
*   㭪 ᮧ ,  ᮮ⢥騥 樨 㯭묨,
*  ஢ ⠫ 樨
*
*/
STATIC FUNCTION CreateBar()

   //  ⮣ ਧ. 
   hBar := BarNew()

   //   
   hEditMenu    := MenuNew( "~஢" )
   hFileMenu    := MenuNew( "~" )
   hSetMenu     := MenuNew( "~४祭" )

   //   
   hSaveSubMenu := MenuNew( "~࠭       " )
   hdBASESub    := MenuNew( "~dBASE       (DBF)  " )

   //  樨
   //   ।஢
   PromptAdd( hEditMenu, E_UNDO,  "⬥~  " )
   PromptAdd( hEditMenu, E_CUT,   "~    " )
   PromptAdd( hEditMenu, E_COPY,  "~஢" )
   PromptAdd( hEditMenu, E_PASTE, "~⠢  " )
   PromptAdd( hEditMenu, E_CLEAR, "~  " )

   //  䠩 
   PromptAdd   ( hFileMenu, F_GET,    " ~ " )
   PromptAdd   ( hFileMenu, F_MEMO,   "~Memoedit()   " )
   PromptAdd   ( hFileMenu, F_SAVE,   "~࠭   Alt-" )

   //  
   PromptAddSub( hFileMenu, F_SAVEAS, hSaveSubMenu )
   PromptAddLine( hFileMenu )
   PromptAdd   ( hFileMenu, F_PRINT,  "~      Alt-" )
   PromptAdd   ( hFileMenu, F_EXIT,   "~室       Alt-" )

   //  ४⥫
   //   頥 (.T.) ᫨ 祭 ⠭.  - (.F.)
   //
   //
   PromptAddToggle( hSetMenu,  S_BELL,   "~", ;
                    {|lChecked| SET(_SET_BELL, lChecked) } )
   PromptAddToggle( hSetMenu,  S_WRAP,   "~७", ;
                    {|lChecked| SET(_SET_WRAP, lChecked) } )
   PromptAddToggle( hSetMenu,  S_CONFIRM,"~ত", ;
                    {|lChecked| SET(_SET_CONFIRM, lChecked) } )

   // ࠭  
   PromptAdd   ( hSaveSubMenu, SA_NORM,  "~ ⥪ (TXT)  " )
   PromptAdd   ( hSaveSubMenu, SA_WK1,   "~Lotus         (WK1)  " )
   PromptAddSub( hSaveSubMenu, SA_DBF, hdBASESub )

   // dBASE 
   PromptAdd( hdBASESub, DB_CLIP, "~Clipper     " )
   PromptAdd( hdBASESub, DB_III,  "dBASE III~+  " )
   PromptAdd( hdBASESub, DB_IV,   "~dBASE IV    " )

   // ⬥ 㯭 樨
   PromptGray( hFileMenu, F_SAVE )
   PromptGray( hFileMenu, F_SAVEAS )

   // ஢ઠ 権, ॡ ஫
   IF SET(_SET_BELL)
      PromptCheck( hSetMenu, S_BELL )
   ENDIF
   IF SET(_SET_WRAP)
      PromptCheck( hSetMenu, S_WRAP )
   ENDIF
   IF SET(_SET_CONFIRM)
      PromptCheck( hSetMenu, S_CONFIRM )
   ENDIF

   // ᮥ   ਧ. 
   MenuAdd( hBar, hFileMenu )
   MenuAdd( hBar, hEditMenu )
   MenuAdd( hBar, hSetMenu )

   //    shortcuts
   PromptQuickKey( hBar, hFileMenu, F_SAVE, K_ALT_S )
   PromptQuickKey( hBar, hFileMenu, F_EXIT, K_ALT_X )
   PromptQuickKey( hBar, hFileMenu, F_PRINT, K_ALT_P )

   RETURN NIL

/***
*  GetProc() --> NIL
*  㭪    READ
*
*/
STATIC FUNCTION GetProc
   LOCAL GetList := {}
   LOCAL cInput  := SPACE(10)
   LOCAL cInput2 := SPACE(10)

   //  ᮮ. 樨 㯭묨
   PromptEnable( hFileMenu, F_SAVE )
   PromptEnable( hFileMenu, F_SAVEAS )

   PromptAction( hFileMenu, F_SAVE, {|| ForceGetExit()} )

   PromptEnable( hEditMenu, E_UNDO )
   PromptEnable( hEditMenu, E_CUT )
   PromptEnable( hEditMenu, E_COPY )
   PromptEnable( hEditMenu, E_PASTE )
   PromptEnable( hEditMenu, E_CLEAR )

   PostExitBlock({|| ForceGetExit()})
   BarInstall(hBar)

   CLS
   SET SCOREBOARD OFF
   BarDisplay(hBar)

   @ 4,0 SAY "ਢ"
   @ 5,0 SAY " ࢮ " get cInput
   @ 6,0 SAY " ஥ " get cInput2
   READ

   BarDeInstall(hBar)
   PostExitBlock()

   IF LASTKEY() != 27
      @ MAXROW(), 0 SAY "࠭..."
      INKEY(2)
   ENDIF
   CLEAR SCREEN
   BarDisplay(hBar)

   RETURN NIL

/***
*  ForceGetExit() --> NIL
*  ஥ 뢠 READ; 뢠  室  
*
*/
STATIC FUNCTION ForceGetExit

   KEYBOARD CHR(K_CTRL_W)

   RETURN NIL

/***

*  MemoProc() --> NIL
*     OMENU-⥬  樨 
*  MEMOEDIT()
*
*/
STATIC FUNCTION MemoProc
   STATIC cString := "   ६ ࠡ ."

   CLS
   BarDisplay( hBar )
   @ 1, 0 to MAXROW(), 78
   cString := MEMOEDIT( cString, 2, 2, MAXROW()-2, 77, .T., "EditIt" )

   RETURN NIL

/***
*  EditIt( nMode, nLine, nCol ) --> ME_DEFAULT
*  짮⥫᪠ 㭪 MEMOEDIT(), ᮤঠ 맮 OMENU-⥬
*
*/
FUNCTION EditIt( nMode, nLine, nCol )

   // 樨   
   IF nMode == ME_UNKEY .OR. nMode == ME_UNKEYX
      // ஢ઠ,     
      BarActivate(hBar, LASTKEY())

      // If their is a request to change through the menu
      IF BarMenuChoice(hBar) != F_MEMO
         RETURN K_CTRL_W
      ENDIF
   ENDIF

   RETURN ME_DEFAULT


/***
*  DummyProc( <cString> ) --> NIL
*  ᯮ  ஢ન,    믮
*/
STATIC FUNCTION DummyProc( cString )

   CLS
   BarDisplay( hBar )

   // ⠭ 㯭 ᮮ. 樨
   PromptGray( hFileMenu, F_SAVE )
   PromptGray( hFileMenu, F_SAVEAS )

   PromptGray( hEditMenu, E_UNDO )
   PromptGray( hEditMenu, E_CUT )
   PromptGray( hEditMenu, E_COPY )
   PromptGray( hEditMenu, E_PASTE )
   PromptGray( hEditMenu, E_CLEAR )

   BarInstall(hBar)
   PostExitBlock( {|| ForceGetExit()} )

   @ 12,0 SAY cString
   InKeyWait(0)

   PostExitBlock()
   BarDeInstall(hBar)

   RETURN NIL