/***
*   Frmrun.prg
*   ⥬ প REPORT FORM Clipper 5.0 ६ ᯮ
*   Copyright (c) 1990 Nantucket Corp.   ࠢ ࠭.
*
*   ஢  ﬨ: /n/w/m
*/


#include "frmdef.ch"
#include "error.ch"

STATIC aReportData, nPageNumber, nLinesLeft, aReportTotals
STATIC aGroupTotals, lFirstPass, lFormFeeds, nMaxLinesAvail

FUNCTION __ReportForm( cFRMName, lPrinter, cAltFile, lNoConsole, bFor, ;
                       bWhile, nNext, nRecord, lRest, lPlain, cHeading, ;
                       lBEject, lSummary )

   LOCAL lPrintOn, lConsoleOn //  ਭ  ᮫
   LOCAL cExtraFile, lExtraState  //  EXTRA
   LOCAL nCol, nGroup
   LOCAL xBreakVal, lBroke := .F.
   LOCAL err

   LOCAL lAnyTotals
   LOCAL lAnySubTotals

   // ஢ઠ । ࠬ஢
   IF cFRMName == NIL
      err := ErrorNew()
      err:severity := 2
      err:genCode := EG_ARG
      err:subSystem := "FRMLBL"
      Eval(ErrorBlock(), err)
   ELSE
	  IF AT( ".", cFRMName ) == 0
		 cFRMName := TRIM( cFRMName ) + ".FRM"
	  ENDIF
   ENDIF

   IF lPrinter == NIL
	  lPrinter	 := .F.
   ENDIF

   IF cHeading == NIL
	  cHeading := ""
   ENDIF

   // ⠭ 室 ன
   lPrintOn   := SET( _SET_PRINTER, lPrinter )

   IF lNoConsole
	  lConsoleOn := SET( _SET_CONSOLE, .F. )
   ENDIF

   IF lPrinter              // 뢮  ਭ
	  lFormFeeds := .T.
   ELSE
	  lFormFeeds := .F.
   ENDIF

   IF (!Empty(cAltFile))        // 뢮  䠩
	  cExtraFile := SET( _SET_EXTRAFILE, cAltFile )
	  lExtraState := SET( _SET_EXTRA, .T. )
   ENDIF


   BEGIN SEQUENCE

    aReportData := __FrmLoad( cFRMName )   // 㧪 䠩 ।   ᨢ
	  nMaxLinesAvail := aReportData[RP_LINES]

    // 䨪 aReportData  ᮮ⢥⢨  ࠬࠬ 
    IF lSummary != NIL           // ⠭ 㬬   ⮫쪮  䫠
		 aReportData[ RP_SUMMARY ] := lSummary
	  ENDIF
	  IF lBEject != NIL
		 aReportData[ RP_BEJECT ]  := .F.
	  ENDIF
    IF lPlain                // ⠭ 䫠 -   㬥樨 ࠭
		 aReportData[ RP_PLAIN ]   := .T.
		 cHeading				   := ""
		 lFormFeeds 			   := .F.
	  ENDIF
	  aReportData[ RP_HEADING ]    := cHeading

    //   , ᫨ 뫮 । SET MARGIN
    // 砭: ⨥   ⮩ ப ਢ 
    // ᯮ짮  REPORT FORM  뢮  ࠭  䠩
    // SET MARGIN, ,  뢮  ਭ  ந室 㤢
	  // aReportData[ RP_LMARGIN ] += SET( _SET_MARGIN )

    nPageNumber := 1             // ⠭ 砫쭮  ࠭
    lFirstPass  := .T.           // ⠭ ࢮ 䫠 ய᪠

	  nLinesLeft  := aReportData[ RP_LINES ]

    // ஢ઠ ॡ ண । 
	  IF aReportData[ RP_BEJECT ]
		 EjectPage()
	  ENDIF

    //  ࢮ砫쭮   ( 砩, ᫨  
    // ᥩ, ⢥ ॡ  ⢨)
	  ReportHeader()

    // 樠 aReportTotals     㯯, ⠪   ,
    // ⠭  0 ⮣  , ᫨ ॡ.  ⠢
    // 祭 NIL
	  aReportTotals := ARRAY( LEN(aReportData[RP_GROUPS]) + 1, ;
							  LEN(aReportData[RP_COLUMNS]) )

    // ⮣  
	  FOR nCol := 1 TO LEN(aReportData[RP_COLUMNS])
		 IF aReportData[RP_COLUMNS,nCol,RC_TOTAL]
			FOR nGroup := 1 TO LEN(aReportTotals)
			   aReportTotals[nGroup,nCol] := 0
			NEXT
		 ENDIF
	  NEXT

    // 樠 ⮣  㯯  ᨢ
	  aGroupTotals := ARRAY( LEN(aReportData[RP_GROUPS]) )

    // 믮 ନ஢  ᨬ  । 㯯 ᥩ
	  DBEval( { || ExecuteReport() }, bFor, bWhile, nNext, nRecord, lRest )

    //  ⮣,    ஢
    // 믮 室  ᥬ 㯯
	  FOR nGroup := LEN(aReportData[RP_GROUPS]) TO 1 STEP -1


     // ஢ઠ  ஬ ⮣  
		 lAnySubTotals := .F.
		 FOR nCol := 1 TO LEN(aReportData[RP_COLUMNS])
			IF aReportData[RP_COLUMNS,nCol,RC_TOTAL]
				lAnySubTotals := .T.
        EXIT          // ..室  ७ 横 ᪠.
			ENDIF
		 NEXT

		 IF !lAnySubTotals
      LOOP            // ᫨  ⮩ 㯯  㦥 ஬ ⮣,
     ENDIF            //  室  砫 横  ᫥饩 㯯.


     // ஢ઠ 室 ண ࠭
		 IF nLinesLeft < 2
			EjectPage()
			IF aReportData[ RP_PLAIN ]
			   nLinesLeft := 1000
			ELSE
			   ReportHeader()
			ENDIF
		 ENDIF

     //  ࢮ ப
     PrintIt( SPACE(aReportData[RP_LMARGIN]) + "** ⮣  " +;
         IF(nGroup==1,"","") + "㯯 **")  // ** Subtotal **","* Subsubtotal *") )

     //  ன ப
		 QQOUT( SPACE(aReportData[RP_LMARGIN]) )
		 FOR nCol := 1 TO LEN(aReportData[RP_COLUMNS])
			IF nCol > 1
			   QQOUT( " " )
			ENDIF
			IF aReportData[RP_COLUMNS,nCol,RC_TOTAL]
			   QQOUT( TRANSFORM(aReportTotals[nGroup+1,nCol], ;
				  aReportData[RP_COLUMNS,nCol,RC_PICT]) )
			ELSE
			   QQOUT( SPACE(aReportData[RP_COLUMNS,nCol,RC_WIDTH]) )
			ENDIF
		 NEXT

     // 뫪 /  ᫥ ப
		 QOUT()

	  NEXT

    //  饣 ⮣
    // ஢ઠ 室 ண ࠭
	  IF nLinesLeft < 2
		 EjectPage()
		 IF aReportData[ RP_PLAIN ]
			nLinesLeft := 1000
		 ELSE
			ReportHeader()
		 ENDIF
	  ENDIF


    //  "⮣"?
	  lAnyTotals := .F.
	  FOR nCol := 1 TO LEN(aReportData[RP_COLUMNS])
		 IF aReportData[RP_COLUMNS,nCol,RC_TOTAL]
			lAnyTotals := .T.
			EXIT
		 ENDIF
	  NEXT


	  IF lAnyTotals

      //  ࢮ ப
      PrintIt( SPACE(aReportData[RP_LMARGIN]) + "*** ⮣ ***" )

      //  ன ப
		  QQOUT( SPACE(aReportData[RP_LMARGIN]) )
		  FOR nCol := 1 TO LEN(aReportData[RP_COLUMNS])
			 IF nCol > 1
				QQOUT( " " )
			 ENDIF
			 IF aReportData[RP_COLUMNS,nCol,RC_TOTAL]
				QQOUT( TRANSFORM(aReportTotals[1,nCol], ;
				   aReportData[RP_COLUMNS,nCol,RC_PICT]) )
			 ELSE
				QQOUT( SPACE(aReportData[RP_COLUMNS,nCol,RC_WIDTH]) )
			 ENDIF
		  NEXT

     // 뫪 /  ᫥ ப
		  QOUT()

	  END


    // ஢ઠ ண  ᫥  
	  IF aReportData[ RP_AEJECT ]
		 EjectPage()
	  ENDIF


   RECOVER USING xBreakVal

	  lBroke := .T.

   END	// Sequence


   // ⪠
   aReportData    := NIL         //  ""
   aReportTotals  := NIL
   aGroupTotals   := NIL
   nPageNumber	  := NIL
   lFirstPass	  := NIL
   nLinesLeft	  := NIL
   lFormFeeds	  := NIL
   nMaxLinesAvail := NIL

   // ⠭:
   SET( _SET_PRINTER, lPrintOn )     // 室 ﭨ ਭ
   SET( _SET_CONSOLE, lConsoleOn )   // 室 ﭨ ᮫

   IF (!Empty(cAltFile))         // 祭 ⥫쭮 䠩
	  SET( _SET_EXTRAFILE, cExtraFile )
	  SET( _SET_EXTRA, lExtraState )
   ENDIF

   IF lBroke
    // । 祭 뢠 
	  BREAK xBreakVal
   END

   RETURN NIL



/***
*		ExecuteReport() --> NIL
*   믮  DBEVAL()     , ᮮ⢥饩
*    ⢨
*/
STATIC FUNCTION ExecuteReport
   LOCAL aRecordHeader  := {}           //   ⥪饩 
   LOCAL aRecordToPrint := {}           //    
   LOCAL nCol                           // 稪  ࠡ  
   LOCAL nGroup                         // 稪  ࠡ  㯯
   LOCAL lGroupChanged  := .F.          //    㯯?
   LOCAL nMaxLines                      // ⢮ ப, 室  
   LOCAL nLine                          // 稪 ப  
   LOCAL cLine                          //  ப ⥪  ࠧ
   LOCAL nLastElement                   // ⥫  ᫥ , ᫨  

   LOCAL lAnySubTotals

   //  ᭮ ⮣  
   FOR nCol := 1 TO LEN(aReportData[RP_COLUMNS])
      IF aReportData[RP_COLUMNS,nCol,RC_TOTAL]
         // 쭥襥 믮  ,  ॡ ⮣
         aReportTotals[ 1 ,nCol] += ;
                  EVAL( aReportData[RP_COLUMNS,nCol,RC_EXP] )
      ENDIF
   NEXT

   // ।   㯯.  ᫨ ,   ᮮ⢥
   // ப  aRecordHeader  ⮦ ( । )
   IF !lFirstPass                       //  믮  ࢮ 室

      //   ᥬ 㯯
      FOR nGroup := LEN(aReportData[RP_GROUPS]) TO 1 STEP -1


     // ஢ઠ 室 ⮦  㯯
		 lAnySubTotals := .F.
		 FOR nCol := 1 TO LEN(aReportData[RP_COLUMNS])
			IF aReportData[RP_COLUMNS,nCol,RC_TOTAL]
         lAnySubTotals := .T.  // ⮦ 
         EXIT           // 室  横  
			ENDIF
		 NEXT

		 IF !lAnySubTotals
      LOOP            // ⮦ ,  ᫥ 㯯
		 ENDIF



         // ᫨  ⮩ 㯯    ।饩 
         IF MakeAStr(EVAL(aReportData[RP_GROUPS,nGroup,RG_EXP]),;
               aReportData[RP_GROUPS,nGroup,RG_TYPE]) != aGroupTotals[nGroup]
            AADD( aRecordHeader,"** ⮣  " + IF(nGroup==1,"","") + "㯯 **")
            AADD( aRecordHeader, "" )

            //      ਭ, ॡ㥬 
            // 㯯  aReportTotals ( 祣, ᫨  ⮦)
            FOR nCol := 1 TO LEN(aReportData[RP_COLUMNS])
               IF aReportData[RP_COLUMNS,nCol,RC_TOTAL]
                  aRecordHeader[ LEN(aRecordHeader) ] += ;
                     TRANSFORM(aReportTotals[nGroup+1,nCol], ;
                     aReportData[RP_COLUMNS,nCol,RC_PICT])
                  // 0  ᫥饩 㯯  aReportTotals
                  aReportTotals[nGroup+1,nCol] := 0
               ELSE
                  aRecordHeader[ LEN(aRecordHeader) ] += ;
                        SPACE(aReportData[RP_COLUMNS,nCol,RC_WIDTH])
               ENDIF
               aRecordHeader[ LEN(aRecordHeader) ] += " "
            NEXT
            // ᢮  ⥫쭮 ஡ (ࠧ⥫)
            //  ᫥ 
            aRecordHeader[LEN(aRecordHeader)] := ;
                  LEFT( aRecordHeader[LEN(aRecordHeader)], ;
                  LEN(aRecordHeader[LEN(aRecordHeader)]) - 1 )
         ENDIF
      NEXT

   ENDIF

   lFirstPass = .F.

   //   aRecordHeader  砥, ᫨  㯯  
   //    ஢

   //   㯯
   FOR nGroup := 1 TO LEN(aReportData[RP_GROUPS])
      // ᫨ 㯯 뫠 
      IF MakeAStr(EVAL(aReportData[RP_GROUPS,nGroup,RG_EXP]),;
            aReportData[RP_GROUPS,nGroup,RG_TYPE]) == aGroupTotals[nGroup]
      ELSE
         AADD( aRecordHeader, "" )   //  ப
         AADD( aRecordHeader, IF(nGroup==1,"** 㯯 ","** 㯯 ") +;
               aReportData[RP_GROUPS,nGroup,RG_HEADER] + " " +;
               MakeAStr(EVAL(aReportData[RP_GROUPS,nGroup,RG_EXP]), ;
               aReportData[RP_GROUPS,nGroup,RG_TYPE]) )
      ENDIF
   NEXT

   //  -   ?
   IF LEN( aRecordHeader ) > 0
      // ஢ઠ 頥  aRecordHeader  ⥪饩 ࠭.
      // ᫨ ,   ᫥
      IF LEN( aRecordHeader ) > nLinesLeft
         EjectPage()
         IF aReportData[ RP_PLAIN ]
            nLinesLeft := 1000
         ELSE
            ReportHeader()
         ENDIF
      ENDIF

      // 뢮 aRecordHeader  뢮 ன⢮,  nLinesLeft
      AEVAL( aRecordHeader, ;
          { | HeaderLine | ;
              PrintIt( SPACE(aReportData[RP_LMARGIN])+ HeaderLine ) ;
          } ;
      )
      nLinesLeft -= LEN( aRecordHeader )

      // ஢ઠ "㯠"    ࠭
      IF nLinesLeft == 0
         EjectPage()
         IF aReportData[ RP_PLAIN ]
            nLinesLeft := 1000
         ELSE
            ReportHeader()
         ENDIF
      ENDIF
   ENDIF

   //  㯯 ⮣
   FOR nCol := 1 TO LEN(aReportData[RP_COLUMNS])
      // 믮, ᫨  ⮦
      IF aReportData[RP_COLUMNS,nCol,RC_TOTAL]
         //   㯯
         FOR nGroup := 1 TO LEN( aReportTotals ) - 1
            aReportTotals[nGroup+1,nCol] += ;
               EVAL( aReportData[RP_COLUMNS,nCol,RC_EXP] )
         NEXT
      ENDIF
   NEXT

   //   室 ﭨ ࠦ 㯯  aGroupTotals
   FOR nGroup := 1 TO LEN(aReportData[RP_GROUPS])
      aGroupTotals[nGroup] := MakeAStr(EVAL(aReportData[RP_GROUPS,nGroup,RG_EXP]),;
                                    aReportData[RP_GROUPS,nGroup,RG_TYPE])
   NEXT

   // 믮 ⮫쪮  ᥩ,    ⮣  
   IF !aReportData[ RP_SUMMARY ]
      // । ᨬ쭮 ⢠ ப   ࠦ
	  nMaxLines := 1	// $BH 2/14/91
      FOR nCol := 1 TO LEN(aReportData[RP_COLUMNS])
         IF aReportData[RP_COLUMNS,nCol,RC_TYPE] $ "CM"
            nMaxLines := MAX(XMLCOUNT(EVAL(aReportData[RP_COLUMNS,nCol,RC_EXP]),;
                         aReportData[RP_COLUMNS,nCol,RC_WIDTH]), nMaxLines)
         ENDIF
      NEXT

      //  ᨢ aRecordToPrint  ᨬ쭮 ॡ㥬 
      //    ⮢ - ""
      ASIZE( aRecordToPrint, nMaxLines )
      AFILL( aRecordToPrint, "" )

      // 㧪 ⥪饩   aRecordToPrint
      FOR nCol := 1 TO LEN(aReportData[RP_COLUMNS])
         FOR nLine := 1 TO nMaxLines
            // ஢ઠ ⨯   ⨯ ᨬ  -
            IF aReportData[RP_COLUMNS,nCol,RC_TYPE] $ "CM"
               // 㧪 ⥪饩 ப ⥪饩   cLine
               cLine := XMEMOLINE(TRIM(EVAL(aReportData[RP_COLUMNS,nCol,RC_EXP])),;
                             aReportData[RP_COLUMNS,nCol,RC_WIDTH], nLine )
               cLine := PADR( cLine, aReportData[RP_COLUMNS,nCol,RC_WIDTH] )
            ELSE
               IF nLine == 1
                  cLine := TRANSFORM(EVAL(aReportData[RP_COLUMNS,nCol,RC_EXP]),;
                           aReportData[RP_COLUMNS,nCol,RC_PICT])
                  cLine := PADR( cLine, aReportData[RP_COLUMNS,nCol,RC_WIDTH] )
               ELSE
                  cLine := SPACE( aReportData[RP_COLUMNS,nCol,RC_WIDTH])
               ENDIF
            ENDIF
            //   饩 ப 
            IF nCol > 1
               aRecordToPrint[ nLine ] += " "
            ENDIF
            aRecordToPrint[ nLine ] += cLine
         NEXT
      NEXT

      // ஢ઠ 頥  aRecordToPrint  ⥪饩 ࠭
      IF LEN( aRecordToPrint ) > nLinesLeft
         //   頥  ⥪饩 ࠭,   
         //  ?  ᫨     .
         IF LEN( aRecordToPrint ) > nMaxLinesAvail
            // ᪠ !  ࠢ  ࠭...
            nLine := 1
            DO WHILE nLine < LEN( aRecordToPrint )
               PrintIt( SPACE(aReportData[RP_LMARGIN]) + aRecordToPrint[nLine] )
               nLine++
               nLinesLeft--
               IF nLinesLeft == 0
                  EjectPage()
                  IF aReportData[ RP_PLAIN ]
                     nLinesLeft := 1000
                  ELSE
                     ReportHeader()
                  ENDIF
               ENDIF
            ENDDO
         ELSE
            EjectPage()
            IF aReportData[ RP_PLAIN ]
               nLinesLeft := 1000
            ELSE
               ReportHeader()
            ENDIF
            AEVAL( aRecordToPrint, ;
               { | RecordLine | ;
                 PrintIt( SPACE(aReportData[RP_LMARGIN])+ RecordLine ) ;
               } ;
            )
            nLinesLeft -= LEN( aRecordToPrint )
         ENDIF
      ELSE
         // 뫪 aRecordToPrint  뢮 ன⢮,  nLinesLeft
         AEVAL( aRecordToPrint, ;
            { | RecordLine | ;
              PrintIt( SPACE(aReportData[RP_LMARGIN])+ RecordLine ) ;
            } ;
         )
         nLinesLeft -= LEN( aRecordToPrint )
      ENDIF

      // ஢ઠ "㯠"    
      IF nLinesLeft == 0
         EjectPage()
         IF aReportData[ RP_PLAIN ]
            nLinesLeft := 1000
         ELSE
            ReportHeader()
         ENDIF
      ENDIF

      //  ஬⪠  ப /ன/ ..
      IF aReportData[ RP_SPACING ] > 1
         IF nLinesLeft > aReportData[ RP_SPACING ] - 1
            FOR nLine := 2 TO aReportData[ RP_SPACING ]
               PrintIt()
               nLinesLeft--
            NEXT
         ENDIF
      ENDIF

   ENDIF    //     ⮣?

   RETURN NIL

STATIC FUNCTION ReportHeader
   LOCAL nLinesInHeader := 0
   LOCAL aPageHeader    := {}
   LOCAL nHeadingLength := aReportData[RP_WIDTH] - aReportData[RP_LMARGIN] - 30
   LOCAL nCol, nLine, nMaxColLength, nGroup, cHeader

   //   饭   aPageHeader

   // 砫 ନ஢ 
   IF !aReportData[ RP_PLAIN ]           // ᫨  饭 , 
      IF aReportData[RP_HEADING] == ""   // ஥ 
         AADD( aPageHeader, " No. " + LTRIM(STR(nPageNumber,6) ))
      ELSE
         nLinesInHeader := XMLCOUNT( aReportData[RP_HEADING], nHeadingLength )
         FOR nLine := 1 TO nLinesInHeader
            AADD( aPageHeader, SPACE(15) + ;
            PADC(TRIM(XMEMOLINE(aReportData[RP_HEADING],nHeadingLength,nLine)),;
                nHeadingLength))
         NEXT
         aPageHeader[ 1 ] := STUFF( aPageHeader[ 1 ], 1, 14, ;
                                    " No. " + TRIM(STR(nPageNumber,6) ))
      ENDIF
      AADD( aPageHeader, DTOC(DATE()) )
   ENDIF

   // ନ஢   ᮮ⢥⢨  FRM
   FOR nLine := 1 TO LEN( aReportData[RP_HEADER] )
		AADD( aPageHeader, ;
				SPACE( ( aReportData[RP_WIDTH] - aReportData[RP_LMARGIN] - ;
						 aReportData[RP_RMARGIN] - ;
						 Len( aReportData[RP_HEADER,nLine] ) ) / 2 ) + ;
						 aReportData[RP_HEADER,nLine] )
   NEXT

   // ᮢ⨬  S87.
   AADD( aPageHeader, "" )

   //   
   nLinesInHeader := LEN( aPageHeader )

   //  ᠬ   
   nMaxColLength := 0
   FOR nCol := 1 TO LEN( aReportData[ RP_COLUMNS ] )
       nMaxColLength := MAX( LEN(aReportData[RP_COLUMNS,nCol,RC_HEADER]), ;
                             nMaxColLength )
   NEXT
   FOR nCol := 1 TO LEN( aReportData[ RP_COLUMNS ] )
      ASIZE( aReportData[RP_COLUMNS,nCol,RC_HEADER], nMaxColLength )
   NEXT

   FOR nLine := 1 TO nMaxColLength
      AADD( aPageHeader, "" )
   NEXT

   FOR nCol := 1 TO LEN(aReportData[RP_COLUMNS])    //   
      FOR nLine := 1 TO nMaxColLength
         IF nCol > 1
            aPageHeader[ nLinesInHeader + nLine ] += " "
         ENDIF
         IF aReportData[RP_COLUMNS,nCol,RC_HEADER,nLine] == NIL
            aPageHeader[ nLinesInHeader + nLine ] += ;
                           SPACE( aReportData[RP_COLUMNS,nCol,RC_WIDTH] )
         ELSE
            IF aReportData[RP_COLUMNS,nCol,RC_TYPE] == "N"
               aPageHeader[ nLinesInHeader + nLine ] += ;
                           PADL(aReportData[RP_COLUMNS,nCol,RC_HEADER,nLine],;
                           aReportData[RP_COLUMNS,nCol,RC_WIDTH])
            ELSE
               aPageHeader[ nLinesInHeader + nLine ] += ;
                           PADR(aReportData[RP_COLUMNS,nCol,RC_HEADER,nLine],;
                           aReportData[RP_COLUMNS,nCol,RC_WIDTH])
            ENDIF
         ENDIF
      NEXT
   NEXT

   // ⠢ (뫮 - ) ⮩ ப    묨  
*   AADD( aPageHeader, "" )    //           15/06/91
  AADD( aPageHeader, "" )

   // 뫪  뢮 ன⢮
   IF lFirstPass
      QOUT()
   ENDIF

   AEVAL( aPageHeader, ;
      { | HeaderLine | ;
         PrintIt( SPACE(aReportData[RP_LMARGIN])+ HeaderLine ) ;
      } ;
   )

   // ⠭  ࠭  㯭  ࠭ ப
   nPageNumber++
   nLinesLeft := aReportData[RP_LINES] - LEN( aPageHeader )
   nMaxLinesAvail := aReportData[RP_LINES] - LEN( aPageHeader )

   RETURN NIL

/***
*		MakeStr( <exp>, <cType> ) --> value
*    ८ࠧ   ⨯  ப     㯯
*/
STATIC FUNCTION MakeAStr( uVar, cType )
   LOCAL cString
   DO CASE
   CASE UPPER(cType) == "D"
      cString := DTOC( uVar )

   CASE UPPER(cType) == "L"
      cString := IF( uVar, '"⨭"', '""' )

   CASE UPPER(cType) == "N"
      cString := STR( uVar )

   CASE UPPER(cType) == "C"
      cString := uVar

   OTHERWISE
      cString := "। ࠦ"
   ENDCASE
   RETURN( cString )

/***
*		PrintIt( <cString> ) --> NIL
*    ப  뫪 / (CRLF)
*/
STATIC FUNCTION PrintIt( cString )

   IF cString == NIL
      cString := ""
   ELSE
    // ।० 뢮 墮⮢ ஡,  ⠪ ७  ப
    //  뢮  ࠭  80- ਭ.  ᯥ祭
    // ᮢ⨬  Summer 87 室  ᨬ 
	  // cString := Trim( cString )
   ENDIF

   QQOUT( cString )
   QOUT()

   RETURN NIL

/***
*		EjectPage() --> NIL
*   ண , ᫨ ⠭ 䫠
*/
STATIC FUNCTION EjectPage
   IF lFormFeeds
      EJECT
   ENDIF
   RETURN NIL


STATIC FUNCTION XMLCOUNT( cString, nLineLength, nTabSize, lWrap )

   // ⠭ 㬥⮢  㬮砭, ᫨   ।
   nLineLength := IF( nLineLength == NIL, 79, nLineLength )
   nTabSize := IF( nTabSize == NIL, 4, nTabSize )
   lWrap := IF( lWrap == NIL, .T., .F. )

   IF nTabSize >= nLineLength
      nTabSize := nLineLength - 1
   ENDIF

   RETURN( MLCOUNT( TRIM(cString), nLineLength, nTabSize, lWrap ) )


STATIC FUNCTION XMEMOLINE( cString, nLineLength, nLineNumber, nTabSize, lWrap )

   // ⠭ 㬥⮢  㬮砭, ᫨   ।
   nLineLength := IF( nLineLength == NIL, 79, nLineLength )
   nLineNumber := IF( nLineNumber == NIL, 1, nLineNumber )
   nTabSize := IF( nTabSize == NIL, 4, nTabSize )
   lWrap := IF( lWrap == NIL, .T., lWrap )

   IF nTabSize >= nLineLength
      nTabSize := nLineLength - 1
   ENDIF

   RETURN( MEMOLINE( cString, nLineLength, nLineNumber, nTabSize, lWrap ) )